

class Slider {
  float val;
  int w = 200;
  int h = 15;
  int x;
  int y;
  
  float min;
  float max;
  
  boolean over = false;
  boolean active = false;
  
  String handle;
  
  Slider(int xp, int yp, String h, float initial, float minim, float maxim) {
    x = xp; 
    y = yp;
    handle = h;
    val = initial;
    min = minim;
    max = maxim;
  }
  
  void show() {
    textSize(12);
    textAlign(LEFT);
    noFill();
    if(over) {
      fill(20);
    }
    if(active) {
      fill(100);
    }
    stroke(255);
    rect(x, y, w, h);
    
    fill(255);
    rect(x+2, y+2, constrain(map(val, min, max, 0, w - 4), 0, w-4), h-4);
    text(handle, x + w + 10, y + 12);
    
    fill(20);
    text(val, x+5, y+12);
    // check hover
    if(mouseX < x+w && mouseX > x && mouseY < y+h && mouseY > y) {
      over = true;
    }
    else {
      over = false;
    }
  }
  
  void downHandler() {
    if(over) {
      active = true;
    }
  }
  
  void upHandler() {
    active = false;
  }
  void dragHandler() {
    if(active){
      val = constrain(map(mouseX - x, 0, w, min, max), min, max);
    }
  }
  
  float getValue() {
    return val;
  }
}
